﻿using NHibernate.Linq;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DatabaseManipulation
{
    public class DatabaseClass
    {
        private List<Product> productList = new List<Product>();
        private List<Employee> employeeList = new List<Employee>();
        private List<Store> storeList = new List<Store>();

        public void InitDataBase()
        {
            try
            {

                using (var session = NHibernateHelper.OpenSession())
                {
                    using (var transaction = session.BeginTransaction())
                    {
                        productList = (List<Product>)session.QueryOver<Product>().List<Product>();
                        employeeList = (List<Employee>)session.QueryOver<Employee>().List<Employee>();
                        storeList = (List<Store>)session.QueryOver<Store>().List<Store>();

                        productList.Clear();
                        employeeList.Clear();
                        storeList.Clear();
                        session.SaveOrUpdate(storeList[0]);
                        transaction.Commit();
                    }
                }
            }
            catch (Exception ex)
            {
            }
        }

        public void DeleteExistingData()
        {
            try
            {
                productList.Clear();
            }
            catch (Exception){}
            try
            {
                employeeList.Clear();
            }
            catch (Exception) { }
            try
            {
                storeList.Clear();
            }
            catch (Exception) { }

            try
            {
                using (var session = NHibernateHelper.OpenSession())
                {
                    using (var transaction = session.BeginTransaction())
                    {
                        productList = (List<Product>)session.QueryOver<Product>().List<Product>();
                        employeeList = (List<Employee>)session.QueryOver<Employee>().List<Employee>();
                        storeList = (List<Store>)session.QueryOver<Store>().List<Store>();
                        session.Delete(productList);
                        session.Delete(employeeList);
                        session.Delete(storeList);
                        session.Update(storeList[0]);
                        transaction.Commit();
                    }
                }
            }
            catch (Exception ex)
            {
            }


        }
        public void SaveSomething(string aFullText)
        {
            string[] authorsList = aFullText.Split(':');            
            string firstname = authorsList[1];
            string lastname = authorsList[2];
            string productname = authorsList[3];

            double productPrice = 0;
            try
            {
                productPrice = double.Parse(authorsList[4], CultureInfo.InvariantCulture);
            }
            catch (Exception) { }
            string storename = authorsList[0];

            using (var session = NHibernateHelper.OpenSession())
            {
                using (var transaction = session.BeginTransaction())
                {
                    bool found = false;
                    Store store = null;
                    Store newstore = new Store { Name = storename };

                    foreach (var item in storeList)
                    {
                        if (item.Name.Contains(storename) == true)
                        {
                            found = true;
                            store = item;
                            break;
                        }
                    }

                    var paramName = new Employee { FirstName = firstname, LastName = lastname };
                    var paramProduct = new Product { Name = productname, Price = productPrice };

                    if (found == true)
                    {
                        AddEmployeesToStore(store, paramName);
                        AddProductsToStore(store, paramProduct);
                        session.SaveOrUpdate(store);
                    }
                    else
                    {
                        AddEmployeesToStore(newstore, paramName);
                        AddProductsToStore(newstore, paramProduct);
                        session.SaveOrUpdate(newstore);
                    }
                    transaction.Commit();
                }
                }

        }

        private void AddProductsToStore(Store store, params Product[] products)
        {
            foreach (var product in products)
            {
                store.AddProduct(product);
            }
        }

        private void AddEmployeesToStore(Store store, params Employee[] employees)
        {
            foreach (var employee in employees)
            {
                store.AddEmployee(employee);
            }
        }

        public int  LoadData(string  storeName, out string firstName, out string lastName, out string productName, out double price)
        {
            int ret = -1;

            string firstNamef = "";
            string lastNamef = "";
            string productNamef = "";
            double pricef = 0.0;

            using (var session = NHibernateHelper.OpenSession())
            {
                using (var transaction = session.BeginTransaction())
                {
                    try
                    {
                        IList<Store> storesMatches = session.QueryOver<Store>().Where(c => c.Name == storeName).List();
                        if (storesMatches.Count > 0)
                        {
                            firstNamef  = storesMatches[0].Staff.FirstOrDefault().FirstName;
                            lastNamef = storesMatches[0].Staff.FirstOrDefault().FirstName;
                            productNamef = storesMatches[0].Products.FirstOrDefault().Name;
                            pricef = storesMatches[0].Products.FirstOrDefault().Price;
                            ret = 0;
                        }
                        else
                        {
                            var allStoreData = session.QueryOver<Store>().List();

                            firstNamef = storesMatches[0].Staff.FirstOrDefault().FirstName;
                            lastNamef = storesMatches[0].Staff.FirstOrDefault().FirstName;
                            productNamef = storesMatches[0].Products.FirstOrDefault().Name;
                            pricef = storesMatches[0].Products.FirstOrDefault().Price;
                            ret = 0;
                        }


                        //var list = session.QueryOver<Product>().List();
                        //var list1 = session.QueryOver<Employee>().List();
                        //var list2 = session.QueryOver<Store>().List();

                        //var customers = from customer in session.Query<Store>()
                        //                select customer;

                        //foreach (var item in customers)
                        //{
                        //    Console.WriteLine(item.Name);
                        //}

                        //Need work on this unfinished
                    }
                    catch (Exception ex)
                    {
                    }
                }
            }


             firstName = firstNamef;
             lastName = lastNamef;
             productName = productNamef;
             price = pricef;
            return ret;
        }

        public void EditCurrent(string aFullText)
        {
            string[] authorsList = aFullText.Split(':');
            string storename = authorsList[0];
            string firstname = authorsList[1];
            string lastname = authorsList[2];
            string productname = authorsList[3];

            double productPrice = 0;
            try
            {
                productPrice = double.Parse(authorsList[4], CultureInfo.InvariantCulture);
            }
            catch (Exception) { }

            using (var session = NHibernateHelper.OpenSession())
            {
                //Bring all from the Store table
                List<Store> storesAll = (List<Store>)session.QueryOver<Store>().List<Store>();
                //Bring all where the storename matches
                IList<Store> storesMatches = session.QueryOver<Store>().Where(c => c.Name == storename).List();
                if (storesMatches.Count > 0)
                {
                    using (var transaction = session.BeginTransaction())
                    {
                        storesMatches[0].Staff.FirstOrDefault().FirstName = firstname;
                        storesMatches[0].Staff.FirstOrDefault().FirstName = lastname;
                        storesMatches[0].Products.FirstOrDefault().Name = productname;
                        storesMatches[0].Products.FirstOrDefault().Price = productPrice;
                        session.Update(storesMatches[0]);
                        transaction.Commit();
                        session.Flush();
                    }
                }
            }
        }

        public void DeleteCurrent(string aFullText)
        {
            using (var session = NHibernateHelper.OpenSession())
            {
                using (var transaction = session.BeginTransaction())
                {
                    List<Store>  stores = (List<Store>)session.QueryOver<Store>().List<Store>();
                    if (stores.Count > 0)
                    {
                        var store = session.Get<Store>(stores[0].Id);
                        session.Delete(store);
                    }
                    transaction.Commit();
                    session.Flush();
                }
            }
        }
    }
}
