﻿using FluentNHibernate.Mapping;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ClassLibrary1
{

    public class SingleTestCycle
    {
        public virtual int Id { get; protected set; }
        public virtual int DoorOpeningTime { get; set; }
        public virtual int DoorClosingTime { get; set; }        
        public virtual int VlowValveOpeningTime { get; set; }
        public virtual int VlowValveClosingTime { get; set; }
        public virtual CompleteOneTest CompleteOneTest { get; set; }
    }




    public class CompleteOneTest
    {
        public virtual int Id { get; protected set; }
        public virtual string StartTime { get; set; }
        public virtual string EndTime { get; set; }
        public virtual IList<SingleTestCycle> SingleTest { get; set; }

        public CompleteOneTest()
        {
            SingleTest = new List<SingleTestCycle>();
        }

        public virtual void AddSingleTest(SingleTestCycle singletest)
        {
            singletest.CompleteOneTest = this;
            SingleTest.Add(singletest);
        }
    }


    public class SingleTestCycleMap : ClassMap<SingleTestCycle>
    {
        public SingleTestCycleMap()
        {
            Id(x => x.Id);
            Map(x => x.DoorOpeningTime);
            Map(x => x.DoorClosingTime);
            Map(x => x.VlowValveOpeningTime);
            Map(x => x.VlowValveClosingTime);            
            References(x => x.CompleteOneTest);
        }
    }


    public class CompleteOneTestMap : ClassMap<CompleteOneTest>
    {
        public CompleteOneTestMap()
        {
            Id(x => x.Id);
            Map(x => x.StartTime);
            Map(x => x.EndTime);
            HasMany(x => x.SingleTest)
              .Inverse()
              .Cascade.All();
        }
    }
}
