﻿using DatabaseManipulation;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {

        private DatabaseClass databaseClass;
        public Form1()
        {
            InitializeComponent();

            databaseClass = new DatabaseClass();
            databaseClass.InitDataBase();
        }

        /// <summary>
        /// Load the first data from the database or if there is a match in store name then is loaded.
        /// If there are multiple match it loads the first one.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_LoadData_Click(object sender, EventArgs e)
        {
            string storename = "My Store";

            storename = textBoxIdTobeLoaded.Text;

            if (storename.Length > 0  && databaseClass != null)
            {
                int ret = -1;
                string firstName = "";
                string lastName = "";
                string productName = "";
                double price = 0.0;
                ret =  databaseClass.LoadData(storename, out firstName, out lastName, out  productName, out  price);
                if (ret == 0)
                {
                    textBox_FirstName.Text = storename;
                    textBox_FirstName.Text = firstName;
                    textBox_LastName.Text = lastName;
                    textBox_ProductName.Text = productName;
                    textBox_ProductPrice.Text = price.ToString();
                }
            }
        }

        private void button_Save_Click(object sender, EventArgs e)
        {
            if (databaseClass != null)
            {
                string fulldata = textBoxIdTobeLoaded.Text + ":" + textBox_FirstName.Text + ":" + textBox_LastName.Text + ":" + textBox_ProductName.Text + ":" + textBox_ProductPrice.Text;
                databaseClass.SaveSomething(fulldata);
            }
        }

        private void button_EditData_Click(object sender, EventArgs e)
        {
            if (databaseClass != null)
            {
                string fulldata = textBoxIdTobeLoaded.Text + ":" + textBox_FirstName.Text + ":" + textBox_LastName.Text + ":" + textBox_ProductName.Text + ":" + textBox_ProductPrice.Text;
                databaseClass.EditCurrent(fulldata);
            }
        }

        private void button_InitDataBase_Click(object sender, EventArgs e)
        {


            if (databaseClass != null)
            {               
                databaseClass.DeleteExistingData();
            }


            try
            {
                System.Diagnostics.Process proc2 = new System.Diagnostics.Process();
                proc2.EnableRaisingEvents = false;
                proc2.StartInfo.FileName = "initmydatabase.bat";
                proc2.Start();
                Thread.Sleep(500);
                databaseClass = new DatabaseClass();
                databaseClass.InitDataBase();
            }
            catch (Exception ex)
            {
                //log.Error("Failed to execute recreatelinkoping.bat " + ex.Message);
            }
        }

        private void buttonDeleteCurrent_Click(object sender, EventArgs e)
        {
            if (databaseClass != null)
            {
                string fulldata = textBoxIdTobeLoaded.Text + ":" + textBox_FirstName.Text + ":" + textBox_LastName.Text + ":" + textBox_ProductName.Text + ":" + textBox_ProductPrice.Text;
                databaseClass.DeleteCurrent(fulldata);
            }
        }
    }
}
